diff --git a/Configurations/50-nonstop.conf b/Configurations/50-nonstop.conf
new file mode 100644
index 000000000000..51034c70aab9
--- /dev/null
+++ b/Configurations/50-nonstop.conf
@@ -0,0 +1,176 @@
+#### Nonstop configurations
+    "nonstop-common" => {
+        inherit_from     => [ "BASE_unix" ],
+        template         => 1,
+        cc               => "c99",
+        cflags           => add_before(picker(debug   => "-g -O0",
+                                              release => "-g -O2") ,"-Wextensions -Wnowarn=203,220,272,734,770,1506 -Wbuild_neutral_library"),
+        perl             => "/usr/bin/perl",
+        lflags           => "-lrld",
+        shared_target    => "self",
+        shared_cflag     => "",
+        shared_ldflag    => "-Wshared",
+        shared_extension => ".so",
+        enable           => ["egd"],
+        dso_scheme       => "DLFCN",
+    },
+    "nonstop-nsx" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose -I/usr/local/include") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose -I/usr/local/include") },
+        lflags           => sub { join(" ",@_,"-lfloss -Wxld='-set floattype neutral_float' -Wsystype=oss") },
+        shared_ldflag    => sub { join(" ",@_,"-lfloss -Wxld='-export_all -set floattype neutral_float -set systype oss' -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1","B_ENDIAN", "OPENSSL_SYSNAME_TANDEM", "OPENSSL_TANDEM_FLOSS"],
+        disable          => ["threads"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+    "nonstop-nsx_put" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose") },
+        lflags           => sub { join(" ",@_,"-lput") },
+        shared_ldflag    => sub { join(" ",@_,"-Wxld='-export_all -set floattype neutral_float -set systype oss' -lput -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_REENTRANT", "_PUT_MODEL_","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1","_ENABLE_FLOSS_THREADS", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+    "nonstop-nsx_64" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wlp64 -Wverbose") },
+        shared_cflag     => sub { join(" ",@_,"-Wlp64 -Wverbose") },
+        lflags           => sub { join(" ",@_,"-lfloss -Wlp64") },
+        shared_ldflag    => sub { join(" ",@_,"-lfloss -Wxld='-export_all -set data_model lp64 -set floattype neutral_float -set systype oss' -Wlp64 -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM", "OPENSSL_TANDEM_FLOSS"],
+        disable          => ["threads"],
+        bn_ops           => "SIXTY_FOUR_BIT",
+    },
+    "nonstop-nsx_64_put" => {
+        inherit_from     => [ "nonstop-common" ],
+        shared_cflag     => sub { join(" ",@_,"-Wlp64 -Wverbose -Wtarget=tns/x") },
+        cflags           => sub { join(" ",@_,"-Wlp64 -Wverbose -Wtarget=tns/x") },
+        lflags           => sub { join(" ",@_,"-Wxld='-set floattype neutral_float -set systype oss' -Wlp64 -lput -Wsystype=oss") },
+        shared_ldflag    => sub { join(" ",@_,"-Wxld='-export_all -set data_model lp64'") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_REENTRANT", "_PUT_MODEL_","_TANDEM_ARCH=3","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1","_ENABLE_FLOSS_THREADS","__TANDEM", "_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM"],
+        bn_ops           => "SIXTY_FOUR_BIT",
+    },
+    "nonstop-nsx_spt" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose -Wtarget=tns/x") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose -Wtarget=tns/x") },
+        lflags           => sub { join(" ",@_,"-lspt -Wextensions") },
+        shared_ldflag    => sub { join(" ",@_,"-Wxld='-export_all -set floattype neutral_float -set systype oss' -lspt -Wextensions -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_REENTRANT", "_SPT_MODEL_","_THREAD_SUPPORT_FUNCTIONS","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1","_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+    "nonstop-nsx_spt_floss" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-I/usr/local/include -Wverbose -Wtarget=tns/x") },
+        shared_cflag     => sub { join(" ",@_,"-I/usr/local/include -Wverbose -Wtarget=tns/x") },
+        lflags           => sub { join(" ",@_,"-lfloss -lspt -Wextensions") },
+        shared_ldflag    => sub { join(" ",@_,"-lfloss -Wxld='-export_all -set floattype neutral_float -set systype oss' -lspt -Wextensions -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_REENTRANT", "_SPT_MODEL_","_THREAD_SUPPORT_FUNCTIONS","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1","_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM","OPENSSL_TANDEM_FLOSS"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+    "nonstop-nsx_g" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose -Wtarget=tns/x") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose -Wtarget=tns/x") },
+        lflags           => sub { join(" ",@_,"-Wsystype=guardian -Wxld='-set systype guardian -set floattype neutral_float'") },
+        shared_ldflag    => sub { join(" ",@_,"-Wxld='-export_all -set floattype neutral_float -soname \$\(\@:lib%.so=%\)  -set systype guardian' -Wsystype=guardian") },
+        #shared_extension => " ",
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1", "_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM", "NO_GETPID"],
+        disable          => ["threads"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+    "nonstop-nsx_g_tandem" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose -Wtarget=tns/x") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose -Wtarget=tns/x") },
+        lflags           => sub { join(" ",@_,"-Wsystype=guardian -Wxld='-set systype guardian -set floattype tandem_float'") },
+        shared_ldflag    => sub { join(" ",@_,"-Wxld='-export_all -set floattype tandem_float -soname \$\(\@:lib%.so=%\)  -set systype guardian' -Wsystype=guardian") },
+        #shared_extension => " ",
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1", "_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM", "NO_GETPID"],
+        disable          => ["threads"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+    "nonstop-nsv" => {
+        inherit_from     => [ "nonstop-nsx" ],
+    },
+    "nonstop-nse" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e -I/usr/local/include") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e -I/usr/local/include") },
+        lflags           => sub { join(" ",@_,"-lfloss") },
+        shared_ldflag    => sub { join(" ",@_,"-lfloss -Weld='-export_all -set floattype neutral_float -set systype oss' -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_TANDEM_ARCH=2","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1","__TANDEM", "_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM", "OPENSSL_TANDEM_FLOSS"],
+        disable          => ["threads"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+    "nonstop-nse_put" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e") },
+        lflags           => sub { join(" ",@_,"-lput") },
+        shared_ldflag    => sub { join(" ",@_,"-Weld='-export_all -set floattype neutral_float -set systype oss' -lput -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_REENTRANT", "_PUT_MODEL_","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1","_ENABLE_FLOSS_THREADS", "_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+    "nonstop-nse_64" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wlp64 -Wverbose -Wtarget=tns/e") },
+        shared_cflag     => sub { join(" ",@_,"-Wlp64 -Wverbose -Wtarget=tns/e") },
+        lflags           => sub { join(" ",@_,"-lfloss -Wlp64") },
+        shared_ldflag    => sub { join(" ",@_,"-lfloss -Weld='-export_all -set data_model lp64  -set floattype neutral_float -set systype oss' -Wlp64 -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1","_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM", "OPENSSL_TANDEM_FLOSS"],
+        disable          => ["threads"],
+        bn_ops           => "SIXTY_FOUR_BIT_LONG RC4_CHAR RC4_CHUNK DES_INT DES_UNROLL BF_PTR",
+    },
+    "nonstop-nse_64_put" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wlp64 -Wverbose -Wtarget=tns/e") },
+        shared_cflag     => sub { join(" ",@_,"-Wlp64 -Wverbose -Wtarget=tns/e") },
+        lflags           => sub { join(" ",@_,"-lput -Wlp64") },
+        shared_ldflag    => sub { join(" ",@_,"-Weld='-export_all -set data_model lp64 -set floattype neutral_float -set systype oss' -Wlp64 -lput -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_REENTRANT", "_PUT_MODEL_","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1","_ENABLE_FLOSS_THREADS", "_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM"],
+        bn_ops           => "SIXTY_FOUR_BIT_LONG RC4_CHAR RC4_CHUNK DES_INT DES_UNROLL BF_PTR",
+    },
+    "nonstop-nse_spt" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e") },
+        lflags           => sub { join(" ",@_,"-lspt -Wextensions") },
+        shared_ldflag    => sub { join(" ",@_,"-Weld='-export_all -set floattype neutral_float -set systype oss' -lspt -Wextensions -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_REENTRANT", "_SPT_MODEL_","_THREAD_SUPPORT_FUNCTIONS","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1", "_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+    "nonstop-nse_spt_floss" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e") },
+        lflags           => sub { join(" ",@_,"-lfloss -lspt -Wextensions") },
+        shared_ldflag    => sub { join(" ",@_,"-lfloss -Weld='-export_all -set floattype neutral_float -set systype oss' -lspt -Wextensions -Wsystype=oss") },
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_REENTRANT", "_SPT_MODEL_","_THREAD_SUPPORT_FUNCTIONS","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1", "_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM", "OPENSSL_TANDEM_FLOSS"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+    "nonstop-nse_g" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e") },
+        lflags           => sub { join(" ",@_,"-Wsystype=guardian -Weld='-set systype guardian'") },
+        shared_ldflag    => sub { join(" ",@_,"-Weld='-set systype guardian -export_all -set floattype neutral_float -soname \$\(\@:lib%.so=%\)' -Wsystype=guardian") },
+        #shared_extension => " ",
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1", "_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM", "NO_GETPID"],
+        disable          => ["threads"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
+
+    "nonstop-nse_g_tandem" => {
+        inherit_from     => [ "nonstop-common" ],
+        cflags           => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e") },
+        shared_cflag     => sub { join(" ",@_,"-Wverbose -Wtarget=tns/e") },
+        lflags           => sub { join(" ",@_,"-Wsystype=guardian -Weld='-set systype guardian -set floattype tandem_float'") },
+        shared_ldflag    => sub { join(" ",@_,"-Wsystype=guardian -Weld='-set systype guardian -export_all -set floattype tandem_float -soname \$\(\@:lib%.so=%\)'") },
+        #shared_extension => " ",
+        defines          => ["OPENSSL_VPROC=\$(OPENSSL_VPROC)","_XOPEN_SOURCE","_XOPEN_SOURCE_EXTENDED=1", "_TANDEM_SOURCE", "B_ENDIAN", "OPENSSL_SYSNAME_TANDEM", "NO_GETPID"],
+        disable          => ["threads"],
+        bn_ops           => "THIRTY_TWO_BIT",
+    },
diff --git a/NOTES.HPNS b/NOTES.HPNS
new file mode 100644
index 000000000000..ec5d72de5960
--- /dev/null
+++ b/NOTES.HPNS
@@ -0,0 +1,42 @@
+## Probably have to be set:
+# COMP_ROOT=$(cygpath -w /path/to/comp_rooot)   # must be path format for system (ie windows)
+# CC=/path/to/c99                               # must be executable by shell
+
+## Optionally 
+# DBGFLAG="--debug"
+# CIPHENABLES="enable-ssl3 enable-ssl3-method enable-weak-ssl-ciphers enable-rc4"
+# onplatform cross compile (nsx->nsi): SYSTEMLIBS="-L/E/cs3/usr/local/lib"
+## VPROC
+## For Itanium:
+# OPENSSL_VPROC_PREFIX=T0085H06
+## For X86:
+# OPENSSL_VPROC_PREFIX=T0085L01
+# export OPENSSL_VPROC=${OPENSSL_VPROC_PREFIX}_$(cat include/openssl/opensslv.h |\
+#  sed -n -e 's/^ *# *define  *OPENSSL_VERSION_TEXT[^"]*"\([^"]*\)"/\1/p' |\
+#  sed -e 's/[. ]/_/g' -e 's/[.-]/_/g' |\
+#  grep -v fips \
+#  )
+
+## Current Configure targets
+#  Guardian targets' libraries will have so-names 'ssl' and 'crypto'
+./Configure nonstop-nsx          --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  no-threads             --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nsx_g        --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  no-threads             --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nsx_put      --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  threads "-D_REENTRANT" --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nsx_spt      --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  threads "-D_REENTRANT" --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nsx_64       --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  no-threads             --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nsx_64_put   --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  threads "-D_REENTRANT" --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nsx_g_tandem --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  no-threads             --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+                                  
+./Configure nonstop-nse          --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  no-threads             --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nse_g        --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  no-threads             --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nse_put      --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  threads "-D_REENTRANT" --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nse_spt      --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  threads "-D_REENTRANT" --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nse_64       --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  no-threads             --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nse_64_put   --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  threads "-D_REENTRANT" --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+./Configure nonstop-nse_g_tandem --prefix=${PWD}/install --openssldir=${PWD}/install no-dynamic-engine  no-threads             --with-rand-seed=egd ${CIPHENABLES} ${DBGFLAG} ${SYSTEMLIBS}
+
+## Build loop:
+#  Configure <...>
+#  Make
+#  ...
+#  Make install
\ No newline at end of file
diff --git a/apps/apps.c b/apps/apps.c
index c06241abb975..a50615e55c2f 100644
--- a/apps/apps.c
+++ b/apps/apps.c
@@ -2451,6 +2451,11 @@ int raw_read_stdin(void *buf, int siz)
     return recv(fileno_stdin(), buf, siz, 0);
 }
 #else
+# if defined(__TANDEM)
+#  if defined(OPENSSL_TANDEM_FLOSS)
+#   include <floss.h(floss_read)>
+#  endif
+# endif
 int raw_read_stdin(void *buf, int siz)
 {
     return read(fileno_stdin(), buf, siz);
@@ -2466,7 +2471,22 @@ int raw_write_stdout(const void *buf, int siz)
     else
         return -1;
 }
+#elif defined(OPENSSL_SYSNAME_TANDEM) && defined(OPENSSL_THREADS) && defined(_SPT_MODEL_)
+# if defined(__TANDEM)
+#  if defined(OPENSSL_TANDEM_FLOSS)
+#   include <floss.h(floss_write)>
+#  endif
+# endif
+int raw_write_stdout(const void *buf,int siz)
+{
+	return write(fileno(stdout),(void*)buf,siz);
+}
 #else
+# if defined(__TANDEM)
+#  if defined(OPENSSL_TANDEM_FLOSS)
+#   include <floss.h(floss_write)>
+#  endif
+# endif
 int raw_write_stdout(const void *buf, int siz)
 {
     return write(fileno_stdout(), buf, siz);
diff --git a/apps/ca.c b/apps/ca.c
index a4a77126f2f2..082bd5e45b99 100644
--- a/apps/ca.c
+++ b/apps/ca.c
@@ -26,7 +26,7 @@
 #ifndef W_OK
 # ifdef OPENSSL_SYS_VMS
 #  include <unistd.h>
-# elif !defined(OPENSSL_SYS_VXWORKS) && !defined(OPENSSL_SYS_WINDOWS)
+# elif !defined(OPENSSL_SYS_VXWORKS) && !defined(OPENSSL_SYS_WINDOWS) && !defined(OPENSSL_SYSNAME_TANDEM)
 #  include <sys/file.h>
 # endif
 #endif
diff --git a/apps/ocsp.c b/apps/ocsp.c
index 27ec94fa6b8d..9fa6ab0a2129 100644
--- a/apps/ocsp.c
+++ b/apps/ocsp.c
@@ -64,7 +64,13 @@
 # define LOG_ERR       2
 #endif
 
-#if defined(OPENSSL_SYS_VXWORKS)
+# if defined(__TANDEM)
+#  if defined(OPENSSL_TANDEM_FLOSS)
+#   include <floss.h(floss_fork)>
+#  endif
+# endif
+
+# if defined(OPENSSL_SYS_VXWORKS)
 /* not supported */
 int setpgid(pid_t pid, pid_t pgid)
 {
diff --git a/apps/s_socket.c b/apps/s_socket.c
index 76f928900207..49a4bf2dcd05 100644
--- a/apps/s_socket.c
+++ b/apps/s_socket.c
@@ -32,6 +32,12 @@ typedef unsigned int u_int;
 # include "s_apps.h"
 # include "internal/sockets.h"
 
+#if defined(__TANDEM)
+# if defined(OPENSSL_TANDEM_FLOSS)
+#  include <floss.h(floss_read)>
+# endif
+#endif
+
 # include <openssl/bio.h>
 # include <openssl/err.h>
 
diff --git a/apps/speed.c b/apps/speed.c
index d4ae7ab7bfde..562d1de4b096 100644
--- a/apps/speed.c
+++ b/apps/speed.c
@@ -32,6 +32,12 @@
 # include OPENSSL_UNISTD
 #endif
 
+#if defined(__TANDEM)
+# if defined(OPENSSL_TANDEM_FLOSS)
+#  include <floss.h(floss_fork)>
+# endif
+#endif
+
 #if defined(_WIN32)
 # include <windows.h>
 #endif
diff --git a/apps/version.c b/apps/version.c
index 2aca1636152b..f0e1dc814904 100644
--- a/apps/version.c
+++ b/apps/version.c
@@ -192,3 +192,12 @@ int version_main(int argc, char **argv)
  end:
     return ret;
 }
+
+
+#if defined(__TANDEM) && defined(OPENSSL_VPROC)
+/* Define a VPROC function for the openssl program */
+# define OPENSSL_VPROC_STRING_(x)    x##_OPENSSL
+# define OPENSSL_VPROC_STRING(x)     OPENSSL_VPROC_STRING_(x)
+# define OPENSSL_VPROC_FUNC          OPENSSL_VPROC_STRING(OPENSSL_VPROC)
+void OPENSSL_VPROC_FUNC(void) {}
+#endif
diff --git a/crypto/conf/conf_def.c b/crypto/conf/conf_def.c
index ca76fa3679b8..651a1cb65aa9 100644
--- a/crypto/conf/conf_def.c
+++ b/crypto/conf/conf_def.c
@@ -11,6 +11,9 @@
 
 #include <stdio.h>
 #include <string.h>
+#ifdef __TANDEM
+#include <strings.h>
+#endif
 #include "internal/cryptlib.h"
 #include "internal/o_dir.h"
 #include <openssl/lhash.h>
diff --git a/crypto/conf/conf_lib.c b/crypto/conf/conf_lib.c
index add1dfa1c181..0c84aac9ae3f 100644
--- a/crypto/conf/conf_lib.c
+++ b/crypto/conf/conf_lib.c
@@ -10,6 +10,9 @@
 #include "e_os.h"
 #include <stdio.h>
 #include <string.h>
+#ifdef __TANDEM
+#include <strings.h>
+#endif
 #include "internal/conf.h"
 #include "crypto/ctype.h"
 #include <openssl/crypto.h>
diff --git a/crypto/cryptlib.c b/crypto/cryptlib.c
index 1f36b20c86ed..fc3c7508df66 100644
--- a/crypto/cryptlib.c
+++ b/crypto/cryptlib.c
@@ -471,3 +471,11 @@ size_t OPENSSL_instrument_bus2(unsigned int *out, size_t cnt, size_t max)
     return 0;
 }
 #endif
+
+#if defined(__TANDEM) && defined(OPENSSL_VPROC)
+/* Define VPROC function for HP NonStop build crypto library */
+# define OPENSSL_VPROC_STRING_(x)    x##_CRYPTO
+# define OPENSSL_VPROC_STRING(x)     OPENSSL_VPROC_STRING_(x)
+# define OPENSSL_VPROC_FUNC          OPENSSL_VPROC_STRING(OPENSSL_VPROC)
+void OPENSSL_VPROC_FUNC(void) {}
+#endif /* __TANDEM */
diff --git a/crypto/dso/dso_dlfcn.c b/crypto/dso/dso_dlfcn.c
index 4719e8f4f337..491f11019a0f 100644
--- a/crypto/dso/dso_dlfcn.c
+++ b/crypto/dso/dso_dlfcn.c
@@ -30,7 +30,7 @@
 #  if defined(__SCO_VERSION__) || defined(_SCO_ELF) || \
      (defined(__osf__) && !defined(RTLD_NEXT))     || \
      (defined(__OpenBSD__) && !defined(RTLD_SELF)) || \
-        defined(__ANDROID__)
+        defined(__ANDROID__) || defined(__TANDEM)
 #   undef HAVE_DLINFO
 #  endif
 # endif
diff --git a/crypto/rand/rand_egd.c b/crypto/rand/rand_egd.c
index da3017df3142..5747ed66ced5 100644
--- a/crypto/rand/rand_egd.c
+++ b/crypto/rand/rand_egd.c
@@ -57,6 +57,69 @@ struct sockaddr_un {
 #  include <string.h>
 #  include <errno.h>
 
+#if defined(OPENSSL_SYSNAME_TANDEM)
+/*
+ * HPNS:
+ *
+ *  Our current MQ 5.3 EGD requies compatability-mode sockets
+ *  This code forces the mode to compatibility if required
+ *  and then restores the mode.
+ *
+ *  Needs review:
+ *
+ *  The better long-term solution is to either run two EGD's each in one of
+ *  the two modes or revise the EGD code to listen on two different sockets
+ *  (each in one of the two modes).
+ */
+_variable
+int hpns_socket(int family,
+                int type,
+                int protocol,
+                char* transport
+               )
+{
+  int  socket_rc;
+  char current_transport[20];
+
+#define AF_UNIX_PORTABILITY    "$ZAFN2"
+#define AF_UNIX_COMPATIBILITY  "$ZPLS"
+
+  if (!_arg_present(transport) || !transport || transport[0] == '\0')
+  {
+    return socket(family,type,protocol);
+  }
+
+  socket_transport_name_get(AF_UNIX,current_transport,20);
+
+  if (strcmp(current_transport,transport) == 0)
+  {
+    return socket(family,type,protocol);
+  }
+
+  /* set the requested socket transport */
+  if (socket_transport_name_set(AF_UNIX,transport))
+  {
+    return -1;
+  }
+
+  socket_rc = socket(family,type,protocol);
+
+  /* set mode back to what it was */
+  if (socket_transport_name_set(AF_UNIX,current_transport))
+  {
+    return -1;
+  }
+
+  return socket_rc;
+}
+
+/*#define socket(a,b,c,...) hpns_socket(a,b,c,__VA_ARGS__) */
+
+int hpns_connect_attempt = 0;
+
+#endif /* defined(OPENSSL_SYS_HPNS) */
+
+
 int RAND_query_egd_bytes(const char *path, unsigned char *buf, int bytes)
 {
     FILE *fp = NULL;
@@ -74,7 +137,11 @@ int RAND_query_egd_bytes(const char *path, unsigned char *buf, int bytes)
         return -1;
     strcpy(addr.sun_path, path);
     i = offsetof(struct sockaddr_un, sun_path) + strlen(path);
+#if defined(OPENSSL_SYSNAME_TANDEM)
+    fd = hpns_socket(AF_UNIX, SOCK_STREAM, 0,AF_UNIX_COMPATIBILITY);
+#else
     fd = socket(AF_UNIX, SOCK_STREAM, 0);
+#endif
     if (fd == -1 || (fp = fdopen(fd, "r+")) == NULL)
         return -1;
     setbuf(fp, NULL);
@@ -103,6 +170,18 @@ int RAND_query_egd_bytes(const char *path, unsigned char *buf, int bytes)
             /* No error, try again */
             break;
         default:
+#if defined(OPENSSL_SYSNAME_TANDEM)
+              if (hpns_connect_attempt == 0)
+              {
+                /* try the other kind of AF_UNIX socket */
+                close(fd);
+                fd = hpns_socket(AF_UNIX, SOCK_STREAM, 0,AF_UNIX_PORTABILITY);
+                if (fd == -1) return (-1);
+                ++hpns_connect_attempt;
+                break;  /* try the connect again */
+              }
+#endif
+
             ret = -1;
             goto err;
         }
diff --git a/crypto/threads_pthread.c b/crypto/threads_pthread.c
index 1774a2b2ac16..aa79536f388d 100644
--- a/crypto/threads_pthread.c
+++ b/crypto/threads_pthread.c
@@ -45,7 +45,11 @@ CRYPTO_RWLOCK *CRYPTO_THREAD_lock_new(void)
     }
 
     pthread_mutexattr_init(&attr);
-    pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE);
+    #if defined(__TANDEM) && defined(_SPT_MODEL_)
+      pthread_mutexattr_setkind_np(&attr,MUTEX_RECURSIVE_NP);
+    #else
+      pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE);
+    #endif
 
     if (pthread_mutex_init(lock, &attr) != 0) {
         pthread_mutexattr_destroy(&attr);
diff --git a/e_os.h b/e_os.h
index 9af7f3758d94..c5dc9b0c9f01 100644
--- a/e_os.h
+++ b/e_os.h
@@ -345,6 +345,63 @@ struct servent *getservbyname(const char *name, const char *proto);
 # endif
 /* end vxworks */
 
+/* ----------------------------- HP NonStop -------------------------------- */
+#ifdef __TANDEM
+#  include <strings.h>
+#  include <netdb.h>
+#  define getservbyname(name,proto)          getservbyname((char*)name,proto)
+#  define gethostbyname(name)                gethostbyname((char*)name)
+#  define ioctlsocket(a,b,c)	ioctl(a,b,c)
+#  ifdef NO_GETPID
+inline int nssgetpid();
+#    ifndef NSSGETPID_MACRO
+#      define NSSGETPID_MACRO
+#      include <cextdecs.h(PROCESSHANDLE_GETMINE_)>
+#      include <cextdecs.h(PROCESSHANDLE_DECOMPOSE_)>
+       inline int nssgetpid()
+       {
+         short phandle[10]={0};
+         union pseudo_pid {
+          struct {
+           short cpu;
+           short pin;
+         } cpu_pin ;
+         int ppid;
+        } ppid = { 0 };
+        PROCESSHANDLE_GETMINE_(phandle);
+        PROCESSHANDLE_DECOMPOSE_(phandle, &ppid.cpu_pin.cpu, &ppid.cpu_pin.pin);     
+        return ppid.ppid;
+       }
+#    endif /* NSSGETPID_MACRO */
+#    define getpid(a) nssgetpid(a)
+#  endif /* NO_GETPID */
+/*#  define setsockopt(a,b,c,d,f) setsockopt(a,b,c,(char*)d,f)*/
+/*#  define getsockopt(a,b,c,d,f) getsockopt(a,b,c,(char*)d,f)*/
+/*#  define connect(a,b,c) connect(a,(struct sockaddr *)b,c)*/
+/*#  define bind(a,b,c) bind(a,(struct sockaddr *)b,c)*/
+/*#  define sendto(a,b,c,d,e,f) sendto(a,(char*)b,c,d,(struct sockaddr *)e,f)*/
+#  if defined(OPENSSL_THREADS) && !defined(_PUT_MODEL_) 
+  /*
+   * HPNS SPT threads
+   */
+#  define  SPT_THREAD_SIGNAL 1
+#  define  SPT_THREAD_AWARE 1
+#  include <spthread.h>
+#   undef close
+#   define close spt_close
+/*
+#   define get_last_socket_error()	errno
+#   define clear_socket_error()	errno=0
+#   define ioctlsocket(a,b,c)	ioctl(a,b,c)
+#   define closesocket(s)		close(s)
+#   define readsocket(s,b,n)	read((s),(char*)(b),(n))
+#   define writesocket(s,b,n)	write((s),(char*)(b),(n)
+*/
+#   define accept(a,b,c)        accept(a,(struct sockaddr *)b,c)
+#   define recvfrom(a,b,c,d,e,f) recvfrom(a,b,(socklen_t)c,d,e,f)
+#  endif
+#endif
+
 # ifdef FUZZING_BUILD_MODE_UNSAFE_FOR_PRODUCTION
 #  define CRYPTO_memcmp memcmp
 # endif
diff --git a/include/internal/sockets.h b/include/internal/sockets.h
index 39186efef207..7d9aa5f5bb98 100644
--- a/include/internal/sockets.h
+++ b/include/internal/sockets.h
@@ -145,6 +145,17 @@ struct servent *PASCAL getservbyname(const char *, const char *);
 #  define closesocket(s)              close(s)
 #  define readsocket(s,b,n)           read((s),(b),(n))
 #  define writesocket(s,b,n)          write((s),(char *)(b),(n))
+# elif defined(OPENSSL_SYSNAME_TANDEM)
+#  if defined(OPENSSL_TANDEM_FLOSS)
+#   include <floss.h(floss_read, floss_write)>
+#   define readsocket(s,b,n)       floss_read((s),(b),(n))
+#   define writesocket(s,b,n)      floss_write((s),(b),(n))
+#  else
+#   define readsocket(s,b,n)       read((s),(b),(n))
+#   define writesocket(s,b,n)      write((s),(b),(n))
+#  endif
+#  define ioctlsocket(a,b,c)      ioctl(a,b,c)
+#  define closesocket(s)          close(s)
 # else
 #  define ioctlsocket(a,b,c)      ioctl(a,b,c)
 #  define closesocket(s)          close(s)
diff --git a/include/openssl/crypto.h b/include/openssl/crypto.h
index 7d0b526236f8..c081eb08649c 100644
--- a/include/openssl/crypto.h
+++ b/include/openssl/crypto.h
@@ -412,7 +412,13 @@ typedef LONG CRYPTO_ONCE;
 #    define CRYPTO_ONCE_STATIC_INIT 0
 #   endif
 #  else
-#   include <pthread.h>
+#   if defined(__TANDEM) && defined(_SPT_MODEL_) 
+#    define  SPT_THREAD_SIGNAL 1
+#    define  SPT_THREAD_AWARE 1
+#    include <spthread.h>
+#   else
+#    include <pthread.h>
+#   endif
 typedef pthread_once_t CRYPTO_ONCE;
 typedef pthread_key_t CRYPTO_THREAD_LOCAL;
 typedef pthread_t CRYPTO_THREAD_ID;
diff --git a/include/openssl/e_os2.h b/include/openssl/e_os2.h
index c7e637c4a46f..f8d3e2391634 100644
--- a/include/openssl/e_os2.h
+++ b/include/openssl/e_os2.h
@@ -132,6 +132,44 @@ extern "C" {
 #  endif
 # endif
 
+/* ---------------------------- HP NONSTOP -------------------------------- */
+# ifdef __TANDEM
+#  ifdef NO_GETPID
+inline int nssgetpid();
+#    ifndef NSSGETPID_MACRO
+#      define NSSGETPID_MACRO
+#      include <cextdecs.h(PROCESSHANDLE_GETMINE_)>
+#      include <cextdecs.h(PROCESSHANDLE_DECOMPOSE_)>
+       inline int nssgetpid()
+       {
+         short phandle[10]={0};
+         union pseudo_pid {
+          struct {
+           short cpu;
+           short pin;
+         } cpu_pin ;
+         int ppid;
+        } ppid = { 0 };
+        PROCESSHANDLE_GETMINE_(phandle);
+        PROCESSHANDLE_DECOMPOSE_(phandle, &ppid.cpu_pin.cpu, &ppid.cpu_pin.pin);     
+        return ppid.ppid;
+       }
+#    endif /* NSSGETPID_MACRO */
+#    define getpid(a) nssgetpid(a)
+#  endif /* NO_GETPID */
+#  ifdef _STRING
+#   include <strings.h>
+#  endif
+# define OPENSSL_USE_BUILD_DATE
+# if defined(OPENSSL_THREADS) && defined(_SPT_MODEL_)
+#  define  SPT_THREAD_SIGNAL 1
+#  define  SPT_THREAD_AWARE 1
+#  include <spthread.h>
+# elif defined(OPENSSL_THREADS) && defined(_PUT_MODEL_)
+#  include <pthread.h>
+# endif
+# endif
+
 /**
  * That's it for OS-specific stuff
  *****************************************************************************/
diff --git a/ssl/ssl_lib.c b/ssl/ssl_lib.c
index 433a53796995..508604bb0d9b 100644
--- a/ssl/ssl_lib.c
+++ b/ssl/ssl_lib.c
@@ -566,6 +566,15 @@ static int ssl_check_allowed_versions(int min_version, int max_version)
     return 1;
 }
 
+#if defined(__TANDEM) && defined(OPENSSL_VPROC)
+/* Define VPROC function for HP NonStop build ssl library */
+# define OPENSSL_VPROC_STRING_(x)    x##_SSL
+# define OPENSSL_VPROC_STRING(x)     OPENSSL_VPROC_STRING_(x)
+# define OPENSSL_VPROC_FUNC          OPENSSL_VPROC_STRING(OPENSSL_VPROC)
+void OPENSSL_VPROC_FUNC(void) {}
+#endif
+
+
 static void clear_ciphers(SSL *s)
 {
     /* clear the current cipher */
diff --git a/test/bntest.c b/test/bntest.c
index 97d08ac0be6b..6bc429da762a 100644
--- a/test/bntest.c
+++ b/test/bntest.c
@@ -10,6 +10,9 @@
 #include <errno.h>
 #include <stdio.h>
 #include <string.h>
+#ifdef __TANDEM
+#include <strings.h>
+#endif
 #include <ctype.h>
 
 #include <openssl/bn.h>
diff --git a/test/drbgtest.c b/test/drbgtest.c
index be001ee18e67..59be8697eb9f 100644
--- a/test/drbgtest.c
+++ b/test/drbgtest.c
@@ -22,6 +22,11 @@
 # include <windows.h>
 #endif
 
+#if defined(__TANDEM)
+# if defined(OPENSSL_TANDEM_FLOSS)
+#  include <floss.h(floss_fork)>
+# endif
+#endif
 
 #if defined(OPENSSL_SYS_UNIX)
 # include <sys/types.h>
diff --git a/test/recipes/01-test_symbol_presence.t b/test/recipes/01-test_symbol_presence.t
index 7f2a2d75b8c5..091fbc3095d5 100644
--- a/test/recipes/01-test_symbol_presence.t
+++ b/test/recipes/01-test_symbol_presence.t
@@ -17,6 +17,8 @@ setup("test_symbol_presence");
 plan skip_all => "Only useful when building shared libraries"
     if disabled("shared");
 
+plan skip_all => "Test is disabled on NonStop" if config('target') =~ m|^nonstop|;
+
 my @libnames = ("crypto", "ssl");
 my $testcount = scalar @libnames;
 
diff --git a/test/recipes/90-test_shlibload.t b/test/recipes/90-test_shlibload.t
index 8372a61e885f..4749c9b697f8 100644
--- a/test/recipes/90-test_shlibload.t
+++ b/test/recipes/90-test_shlibload.t
@@ -21,6 +21,7 @@ use configdata;
 plan skip_all => "Test only supported in a shared build" if disabled("shared");
 plan skip_all => "Test is disabled on AIX" if config('target') =~ m|^aix|;
 plan skip_all => "Test is disabled on VMS" if config('target') =~ m|^vms|;
+plan skip_all => "Test is disabled on NonStop" if config('target') =~ m|^nonstop|;
 plan skip_all => "Test only supported in a dso build" if disabled("dso");
 
 plan tests => 10;
diff --git a/test/ssltestlib.c b/test/ssltestlib.c
index 456afdf4716e..82835ad89590 100644
--- a/test/ssltestlib.c
+++ b/test/ssltestlib.c
@@ -24,6 +24,10 @@ static ossl_inline void ossl_sleep(unsigned int millis)
     ts.tv_sec = (long int) (millis / 1000);
     ts.tv_nsec = (long int) (millis % 1000) * 1000000ul;
     nanosleep(&ts, NULL);
+# elif defined(__TANDEM) && !defined(_REENTRANT)    
+    #include <cextdecs.h(PROCESS_DELAY_)>
+    /* HPNS does not support usleep for non threaded apps */
+    PROCESS_DELAY_(millis * 1000);
 # else
     usleep(millis * 1000);
 # endif
